con
  _CLKMODE      = XTAL1 + PLL16X                        
  _XINFREQ      = 5_000_000

  LCDBasePin    = 21

{{
Just some test-code for the LCD driver. It writes some text to a 16x2 display, changes some
user-defined characters and counts up in hex endlessly. Not a big thing yet.

If you have different clock-settings, you might want to change the timing constants defined
in the driver ( w500ns, w5ms and w500us ).

For understanding the CMD_INSTR, please find a list of display instructions in the driver.
}}

obj
  LCD: "BenkyLCDdriver"
  PWM: "PWM_32_v2"
  rndm: "RealRandom"

var
  long stack[10]
    
pub main | i, b, v
  rndm.start

  outa[4] := 1 
  dira[4] := 1

  LCD.start( LCDBasePin,0 )
  LCD.exec( LCD#CMD_INSTR, %10000000 ) ' this sets the 'cursor' position
  LCD.exec( LCD#CMD_PRINT, @frm1 )

  cognew( graph, @stack )

  waitcnt( clkfreq*10 + cnt )

  clear
  repeat i from 0 to 15
    pixel( i, i )
    pixel( 39-i, i )
    pixel( i, 15 - i )
    pixel( 39-i, 15 - i )

  waitcnt( clkfreq*10 + cnt )

  clear
  repeat
    b:=rndm.random
    v:=rndm.random
    b&=7
    v&=15
    bar( b, v )
    waitcnt( clkfreq/30+cnt)

pub bar( x, h ) | i
  repeat i from 15 to 0
    if (i-h)>0
      byte[@buf1+(i>>3)*64][(i&7)+x<<3]:=$1f
    else    
      byte[@buf1+(i>>3)*64][(i&7)+x<<3]:=$00

pub graph
  repeat
    LCD.exec( LCD#CMD_INSTR, %01000000 ) ' set the character RAM address to 0
    LCD.exec( LCD#CMD_SETCHAR, @buf1 )  ' Power plug
    LCD.exec( LCD#CMD_SETCHAR, @buf1+8 )  ' Rails
    LCD.exec( LCD#CMD_SETCHAR, @buf1+16 )  ' Rails
    LCD.exec( LCD#CMD_SETCHAR, @buf1+24 )  ' Rails
    LCD.exec( LCD#CMD_SETCHAR, @buf1+32 )  ' Rails
    LCD.exec( LCD#CMD_SETCHAR, @buf1+40 )  ' Rails
    LCD.exec( LCD#CMD_SETCHAR, @buf1+48 )  ' Rails
    LCD.exec( LCD#CMD_SETCHAR, @buf1+56 )  ' Rails
    LCD.exec( LCD#CMD_INSTR, %10000000+$44 ) ' this sets the 'cursor' position
    LCD.exec( LCD#CMD_PRINTN, @inter1 + 8<<16)
    LCD.exec( LCD#CMD_INSTR, %10000000+$44 ) ' this sets the 'cursor' position
    waitcnt( clkfreq/30+cnt )   
    LCD.exec( LCD#CMD_PRINTN, @leerst + 8<<16)
    LCD.exec( LCD#CMD_INSTR, %01000000 ) ' set the character RAM address to 0
    LCD.exec( LCD#CMD_SETCHAR, @buf2 )  ' Power plug
    LCD.exec( LCD#CMD_SETCHAR, @buf2+8 )  ' Rails
    LCD.exec( LCD#CMD_SETCHAR, @buf2+16 )  ' Rails
    LCD.exec( LCD#CMD_SETCHAR, @buf2+24 )  ' Rails
    LCD.exec( LCD#CMD_SETCHAR, @buf2+32 )  ' Rails
    LCD.exec( LCD#CMD_SETCHAR, @buf2+40 )  ' Rails
    LCD.exec( LCD#CMD_SETCHAR, @buf2+48 )  ' Rails
    LCD.exec( LCD#CMD_SETCHAR, @buf2+56 )  ' Rails
    LCD.exec( LCD#CMD_INSTR, %10000000 + $14 ) ' this sets the 'cursor' position
    LCD.exec( LCD#CMD_PRINTN, @inter1 + 8<<16)
    waitcnt( clkfreq/30+cnt )   
    LCD.exec( LCD#CMD_INSTR, %10000000 + $14 ) ' this sets the 'cursor' position
    LCD.exec( LCD#CMD_PRINTN, @leerst + 8<<16)

pub clear | i
  bytefill( @buf1, 0, 128 )

pub pixel(x, y)
  if y<8
    byte[@buf1][(x/5)*8+y]|= |<(4-x//5)  
  else
    byte[@buf2][(x/5)*8+y-8]|= |<(4-x//5)
      
dat
frm1  byte 255,"Graphics",255,255,"Demo",255,0
frm2  byte 255

buf1  byte %11111,%11111,%11000,%11000,%11000,%11000,%11000,%11111
      byte %11100,%11110,%00111,%00011,%00011,%00111,%11110,%11100
      byte %00000,%00000,%00110,%00110,%00000,%00000,%00110,%00110
      byte %00000,%00000,%00000,%01111,%11100,%11000,%11000,%11000
      byte %00000,%00000,%00000,%10000,%11000,%11000,%11000,%11000
      byte %00000,%00000,%00011,%00100,%01000,%01001,%10000,%10000
      byte %00000,%11111,%00000,%00000,%00000,%10001,%11011,%11011
      byte %00000,%00000,%11000,%00100,%00010,%10010,%00001,%00001

buf2  byte %11111,%11000,%11000,%11000,%11000,%11000,%11111,%11111
      byte %11100,%11110,%00111,%00011,%00011,%00111,%11110,%11100
      byte %00110,%00110,%00111,%00010,%00000,%00000,%00011,%01111
      byte %01111,%00000,%00000,%00001,%00111,%11110,%11000,%00000
      byte %11000,%11000,%10000,%10000,%00000,%00000,%00000,%00000
      byte %10000,%10000,%01001,%01000,%00100,%00011,%00000,%00000
      byte %00000,%00000,%00000,%11111,%00000,%00000,%11111,%00000
      byte %00001,%00001,%10010,%00010,%00100,%11000,%00000,%00000

inter1 byte 0,1,2,3,4,5,6,7
leerst byte "        "
